﻿using System;
using System.ServiceModel ;

namespace client
{
    public class CallbackHandler : ICalculatorDuplexCallback 
    {
        public void Equals(double result)
        {
            Console.WriteLine("Result ({0})", result);
        }
        public void Equation(string equation)
        {
            Console.WriteLine("Equation({0})", equation);
        }

    }
    class Program
    {
        static void Main(string[] args)
        {
            //创建上下文实例
            InstanceContext instanceContext = new InstanceContext(new CallbackHandler());
            //使用上下文实例来创建客户端实例
            CalculatorDuplexClient client = new CalculatorDuplexClient(instanceContext);
            Console.WriteLine("Press <ENTER> to terminate client once the output is displayed.");
            Console.WriteLine();

            // Call the AddTo service operation.
            double value = 100.00D;
            client.AddTo(value);

            // Call the SubtractFrom service operation.
            value = 50.00D;
            client.SubtractFrom(value);

            // Call the MultiplyBy service operation.
            value = 17.65D;
            client.MultiplyBy(value);

            // Call the DivideBy service operation.
            value = 2.00D;
            client.DivideBy(value);

            // Complete equation
            client.Clear();

            Console.ReadKey ();

            //Closing the client gracefully closes the connection and cleans up resources
            client.Close();
        }
    }
}
